# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class AgentWithFqn(UniversalBaseModel):
    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    +sort=1
    +label=Name
    +message=The name should start with lowercase alphabets  and can contain alphanumeric and can include '-' in between
    +usage=Name of the entity
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    +sort=2
    +label=Description
    """

    metadata: typing.Dict[str, typing.Optional[typing.Any]] = pydantic.Field()
    """
    +label=Metadata
    +usage=Key value metadata. Should be valid JSON. For e.g. `{"business-unit": "sales", "quality": "good", "rating": 4.5}`
    +uiType=JsonInput
    +uiProps={"descriptionInline":true}
    """

    version_alias: typing.Optional[str] = pydantic.Field(default=None)
    """
    +label=Version Alias
    +usage=Version alias is alternate, ideally human readable, version string to reference an artifact version. It should start with `v` followed by alphanumeric and it can include `.` and `-` in between (e.g. `v1.0.0`, `v1-prod`, `v3-dev`, etc)
    +message=The version alias should start with `v` followed by alphanumeric and can include `.` and `-` in between (e.g. `v1.0.0`, `v1-prod`, `v3-dev`, etc)
    +uiProps={"descriptionInline":true}
    +placeholder=v1.0.0
    """

    ml_repo: typing.Optional[str] = pydantic.Field(default=None)
    """
    +label=ML Repo
    +usage=Name of the ML Repo
    +uiType=Hidden
    """

    version: typing.Optional[int] = pydantic.Field(default=None)
    """
    +label=Version of the entity
    +usage=Version of the entity
    +uiType=Hidden
    """

    type: typing.Literal["agent"] = pydantic.Field(default="agent")
    """
    +value=agent
    +usage=Type of the entity
    """

    available_tools: typing.List[str] = pydantic.Field()
    """
    +sort=30
    +uiType=Hidden
    +label=Tools
    +usage=Tools available to the agent
    +uiProps={"descriptionInline":true}
    """

    goal: str = pydantic.Field()
    """
    +sort=10
    +uiType=TextArea
    +label=Goal
    +usage=Short form description. Will be used as `description` when this agent is used as a tool.
    +uiProps={"descriptionInline":true}
    """

    instruction: str = pydantic.Field()
    """
    `instruction` is the system prompt for now. (2.5 * 1024)
    +sort=20
    +uiType=AgentInstructions
    +uiProps={"helpText":"Use the syntax ${Tool FQN} to reference a tool, and ${AGENT FQN} to reference another agent"}
    +label=Instructions
    +usage=Instructions for the agent to follow to achieve the goal
    +uiProps={"descriptionInline":true}
    """

    model_id: str = pydantic.Field()
    """
    +sort=40
    +uiType=EnabledModelSelector
    +uiProps={"searchable":true,"modelType":"chat","providerType":"openai"}
    +label=Model
    +usage=Model to use when running the agent
    """

    id: str = pydantic.Field()
    """
    +usage=ID of the agent
    """

    fqn: str = pydantic.Field()
    """
    +usage=FQN of the agent
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
