# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
from .chat_prompt_manifest_messages_item import ChatPromptManifestMessagesItem
from .model_configuration import ModelConfiguration
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class ChatPromptManifest(UniversalBaseModel):
    """
    Chat Prompt manifest.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    +sort=1
    +label=Name
    +message=The name should start with lowercase alphabets  and can contain alphanumeric and can include '-' in between
    +usage=Name of the entity
    """

    description: typing.Optional[str] = pydantic.Field(default=None)
    """
    +sort=2
    +label=Description
    """

    metadata: typing.Dict[str, typing.Optional[typing.Any]] = pydantic.Field()
    """
    +label=Metadata
    +usage=Key value metadata. Should be valid JSON. For e.g. `{"business-unit": "sales", "quality": "good", "rating": 4.5}`
    +uiType=JsonInput
    +uiProps={"descriptionInline":true}
    """

    version_alias: typing.Optional[str] = pydantic.Field(default=None)
    """
    +label=Version Alias
    +usage=Version alias is alternate, ideally human readable, version string to reference an artifact version. It should start with `v` followed by alphanumeric and it can include `.` and `-` in between (e.g. `v1.0.0`, `v1-prod`, `v3-dev`, etc)
    +message=The version alias should start with `v` followed by alphanumeric and can include `.` and `-` in between (e.g. `v1.0.0`, `v1-prod`, `v3-dev`, etc)
    +uiProps={"descriptionInline":true}
    +placeholder=v1.0.0
    """

    ml_repo: typing.Optional[str] = pydantic.Field(default=None)
    """
    +label=ML Repo
    +usage=Name of the ML Repo
    +uiType=Hidden
    """

    version: typing.Optional[int] = pydantic.Field(default=None)
    """
    +label=Version of the entity
    +usage=Version of the entity
    +uiType=Hidden
    """

    type: typing.Literal["chat_prompt"] = "chat_prompt"
    messages: typing.List[ChatPromptManifestMessagesItem] = pydantic.Field()
    """
    +sort=4000
    +label=Messages in the chat conversation
    +usage=List of messages in the chat conversation, must be non-empty
    """

    variables: typing.Optional[typing.Dict[str, str]] = pydantic.Field(default=None)
    """
    +label=Variables
    +usage=Variables referenced in messages and that can be replaced when running generation
    +sort=5000
    """

    model_configuration: ModelConfiguration

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
