# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
from .sklearn_serialization_format import SklearnSerializationFormat
from .sklearn_model_schema import SklearnModelSchema
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class SklearnFramework(UniversalBaseModel):
    """
    +label=Sklearn
    +icon=sklearn
    """

    type: typing.Literal["sklearn"] = pydantic.Field(default="sklearn")
    """
    +label=Type
    +usage=Type of the framework
    +value=sklearn
    """

    model_filepath: typing.Optional[str] = pydantic.Field(default=None)
    """
    +label=Model file path
    +usage=Relative path to the model file in the model version contents
    +uiProps={"descriptionInline":true}
    """

    serialization_format: typing.Optional[SklearnSerializationFormat] = None
    model_schema: typing.Optional[SklearnModelSchema] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
